
Redmine - Defect #8225

Revisions that reference issues are duplicated if their repository is listed for a project and its

subprojects

2011-04-26 01:18 - Ari Johnson

Status: New Start date: 2011-04-26

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version:    

Resolution: Duplicate Affected version: 1.1.2

Description

If you have a project with a configured SCM repository and it has a subproject with the same SCM repository configured (e.g., if you

have a subproject for a specific category of work on the main project and they have the same repository specified in Redmine), then

a revision in the SCM repository that references an issue by its number will be duplicated in the list of revisions referencing that

issue.

The reason for this is that Changeset::scan_comment_for_issue_ids in app/models/changeset.rb does not check whether the

changeset and issue belong to the same project, so the revision will end up being referenced to the issue once in the project that

owns the issue and once in each other project that shares the SCM repository, even though they do not own the issue.

This problem exists in the current 1.1-stable branch in svn, as of r5548 (last change to 1.1-stable appears to be r5503).

Related issues:

Is duplicate of Redmine - Defect #6857: git references leaking from subprojec... New 2010-11-09

History

#1 - 2011-04-26 01:20 - Ari Johnson

- File redmine_1.1-stable_r5503_fix_issue_8225.diff added

Here is a patch that resolves the problem.  It makes one change in total, to line 128 of app/models/changeset.rb which, after applying this patch, will

verify that the issue and changeset have the same project before adding the reference.  It has been lightly tested in a working environment.

#2 - 2011-04-27 23:10 - Roman wegwg

erergergeregerg

#3 - 2011-04-29 15:24 - Bernhard Furtmueller

relates or better duplicates #6857

#4 - 2011-06-16 00:11 - Colin Mollenhour

The patch is flawed. If the subproject has a repo that is different from the parent project but the commit message in the subproject repo references an

issue in the parent project (I do this all the time) then the issue would not be linked with your patch. It needs to instead truly check for duplicates rather

than requiring exact issue-project-repo match. Or maybe it should be configurable, but I do agree the duplicate commit links are annoying.

#5 - 2011-08-24 09:14 - Etienne Massip

- Resolution set to Duplicate

Files

redmine_1.1-stable_r5503_fix_issue_8225.diff 598 Bytes 2011-04-25 Ari Johnson
